#include <QtWidgets>
#include <QPdfWriter>
#include <QtPrintSupport>

int main(int argc, char **argv)
{
    QApplication a(argc, argv);
QPainter lPainter;
	QPen lPen;
	QBrush lBrush;
	// draw blue Raster Image
	//QPicture lRasterImage;
	QImage lRasterImage(2970, 2100, QImage::Format_ARGB32_Premultiplied);
	lRasterImage.fill(Qt::transparent);
	lPainter.begin(&lRasterImage);
	lPen.setColor(Qt::blue);
	lBrush.setColor(Qt::blue);
	lBrush.setStyle(Qt::SolidPattern);
	lPainter.setPen(lPen);
	lPainter.setBrush(lBrush);
	lPainter.drawRect(100, 1050, 2770, 150);
	lPainter.end();

	//lRasterImage.save(QString("%1//outRaster.png").arg(lDir), "PNG");
	 

	// draw Out Image with Raster and Vector
	QImage lOutImage(2970, 2100, QImage::Format_ARGB32_Premultiplied);
	lOutImage.fill(Qt::transparent);


	QPdfWriter lPdfWriter(QString("Output_QPdfWriter.pdf"));
	lPdfWriter.setPageSize(QPrinter::A4);
	lPdfWriter.setPageOrientation(QPageLayout::Landscape);
	lPdfWriter.setResolution(300);
	lPdfWriter.setPdfVersion(QPagedPaintDevice::PdfVersion_A1b);


	QList<QPaintDevice*> lDeviceList;
	lDeviceList.push_back(&lPrinter);
	lDeviceList.push_back(&lPdfWriter);
	lDeviceList.push_back(&lOutImage);

	for(QPaintDevice* lDevice: lDeviceList) {

		// draw red Vector
		lPainter.begin(lDevice);
		lPainter.save();
		lPen.setColor(Qt::red);
		lBrush.setColor(Qt::red);
		lPainter.setPen(lPen);
		lPainter.setBrush(lBrush);
		lPainter.drawRect(100, 1000, 2770, 100);
		lPainter.restore();

		// draw blue Raster Image
		lPainter.save();
		lPainter.setOpacity(0.5);
		//lPainter.drawPicture(0,0, lRasterImage);
		lPainter.drawImage(QRectF(0, 0, 2970, 2100), lRasterImage);
		lPainter.restore();

		// draw green Vector
		lPainter.save();
		lPainter.setOpacity(0.5);
		lPen.setColor(Qt::green);
		lBrush.setColor(Qt::green);
		lPainter.setPen(lPen);
		lPainter.setBrush(lBrush);
		lPainter.drawRect(100, 1150, 2770, 100);
		lPainter.end();
	}
	lOutImage.save(QString("outimg.png"), "PNG");
    return 0;
}
